#ifndef __DEFINITONS_H
#define __DEFINITONS_H

#define LOGGING

#ifdef LOGGING

#define LOG if (fLogLevel > 0) printf
#define LOG_ERROR printf
#define LOGX printf
#define LOG2 if (fLogLevel > 1) printf
#define LOG3 if (fLogLevel > 2) printf
#define HLOG Log
#define HAMMER_LOG hammer_log

#else

#define LOG
#define LOG_ERROR
#define LOGX
#define LOG2
#define LOG3
#define HLOG
#define HAMMER_LOG

#endif

#define SET_SHORT(addr, offset, value) \
	addr[offset] = value & 0x00ff; addr[offset + 1] = (value & 0xff00) >> 8
#define GET_SHORT(addr, offset) \
	 (addr[(offset) + 1] * 256 + addr[(offset)])

#define SET_LONG(addr, offset, value) \
	addr[offset] = value & 0x000000ff;             addr[offset + 1] = (value & 0x0000ff00) >> 8; \
	addr[offset + 2] = (value & 0x00ff0000) >> 16; addr[offset + 3] = (value & 0xff000000) >> 24;
#define GET_LONG(addr, offset) \
	 ((addr[(offset) + 3] << 24) + (addr[(offset) + 2] << 16) + (addr[(offset) + 1] << 8) + addr[(offset)])

#define SET_SHORT_N(addr, offset, value) \
	* (Short *) (&addr[offset]) = value
#define SET_ULONG_N(addr, offset, value) \
	* (ULong *) (&addr[offset]) = value
#define GET_SHORT_N(addr, offset) \
	* (Short *) (&addr[offset])
#define GET_ULONG_N(addr, offset) \
	* (ULong *) (&addr[offset])
	
#define NUM_ELEMENTS(x) (sizeof (x)/sizeof (x[0]))	

#endif
